/*
This program plots distributions from CompHEP-output txt-files in Root;
it can built plots with imposing curves
*/
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <stdio.h>
#include "TROOT.h"
#include "TCanvas.h"
#include "TClass.h"
#include "TDirectory.h"
#include "TStyle.h"
#include "TText.h"
#include "TBox.h"
#include "TCanvasImp.h"
#include "TDialogCanvas.h"
#include "TGuiFactory.h"
#include "TEnv.h"
#include "TError.h"
#include "TContextMenu.h"
#include "TControlBar.h"
#include "TInterpreter.h"
#include "TApplication.h"
#include "TColor.h"
#include "TVirtualPadEditor.h"
#include "TVirtualPad.h"
#include "TLatex.h"
#include "TLine.h"
#include "TBox.h"
#include "TH2.h"
#include "TMarker.h"
#include "TLegend.h"
#include "TLegendEntry.h"
#include "TF1.h"
#include "TFile.h"
#include <TMLPAnalyzer.h>
#include "TEventList.h"
#include "TSystem.h"
#include "TTree.h"
#include "TBranch.h"
#include "TPad.h"
#include "TH1.h"
#include "TGraph.h"
#include "TString.h"
#include "TPostScript.h"
#include <TMath.h>
#include <TAxis.h>

/*
First of all you have to save CompHEP-GUI-distributions (in numerical part of CompHEP) in tab_*.txt -files with corresponding numbers
*/

void read_graph_file(TGraph * gr, char * fname, char *ydim, double tot_square);

void tab_plots(int ntab)
{
  int gif = 1;  // 0 = don't print .gif    1 = print .gif
  int eps = 0;  // 0 = don't print .eps    1 = print .eps
 int numlines=3; //number of curves on one plot

 char procName[100]="u,#bar{d}#rightarrow #nu,#bar{#mu},b,#bar{b}\0"; // Title of the plot
 

 vector<string> xtitle(12);  //titles of the X-axis for the number of different distributions
 vector<string> file1(3);

//  char ytitle[]="Diff. cross section [pb/GeV]"; //title of Y axis
 TLegend *leg = new TLegend(0.75,0.75,0.89,0.89);   // horizontal, 

   gStyle->SetOptStat(0000000);
   gStyle->SetStatFormat("f");
   gStyle->SetTitleX(0.3);
   gStyle->SetTitleYOffset(1.4);

TH1* test1= new TH1F();
TH1* test2= new TH1F();
TH1* test3= new TH1F();
TGraph *gr1= new TGraph(); 
TGraph *gr2= new TGraph(); 
TGraph *gr3= new TGraph(); 
TCanvas *c1 = new TCanvas("c1");
// c1->SetLogy(1); // to logarithm scale of Y axis
char strNum[2];
char *ydim="[pb/GeV]"; //title of Y axis, to be changed later

// x-axis labels for the distributions

xtitle[0]="P_{T}#nu";
xtitle[1]="#eta_{#nu}";


 string yTitle="d#sigma/d"+xtitle[ntab-1] + ydim;
// tab files with the same number in filename from different folders add to the same plot
file1[0]="Tutorial_1/tab_";
file1[1]="Tutorial_2/tab_";
file1[2]="Tutorial_3/tab_";

string file2=".txt";   //extension of tab files
string outputname1="Plot_";  //prefix of output eps/gif files

sprintf(strNum,"%d",ntab);  // convert Integer into String
 TString Outfileeps=outputname1 + strNum + ".eps";
 TString Outfilegif=outputname1 + strNum + ".gif";


for(int nfile=0; nfile<numlines; nfile++)
   {
    string ff=file1[nfile] + strNum + file2;
    char *fname=ff.c_str();
    double area_under_curve = 0;
    double norm_area_under_curve =0;
    double tot_square ;
//    cout<<"FILE: "<< fname<< endl;

    if(nfile==0)
	{
    read_graph_file(gr1, fname, ydim, 1);
    area_under_curve = read_graph_file(gr1, fname, ydim, 1) ;
    norm_area_under_curve = area_under_curve;
    cout << fname <<  "  Area under the curve :  " << area_under_curve << endl;
/* To draw normalized plots; you need to comment next two lines to drawing usual plots */
//    norm_area_under_curve = read_graph_file(gr1, fname, ydim, area_under_curve);
//    cout << fname <<  "  Area under the normalized curve :  " << norm_area_under_curve << endl;
	}

    if(nfile==1)
	{
    read_graph_file(gr2, fname, ydim, 1);
    area_under_curve = read_graph_file(gr2, fname, ydim, 1) ;
    norm_area_under_curve = area_under_curve;
    cout << fname <<  "  Area under the curve :  " << area_under_curve << endl;
/* To draw normalized plots; you need to comment next two lines to drawing usual plots */
//    norm_area_under_curve = read_graph_file(gr2, fname, ydim, area_under_curve);
//    cout << fname <<  "  Area under the normalized curve :  " << norm_area_under_curve << endl;
	}

    if(nfile==2)
	{
    read_graph_file(gr3, fname, ydim, 1);
    area_under_curve = read_graph_file(gr3, fname, ydim, 1) ;
    norm_area_under_curve = area_under_curve;
    cout << fname <<  "  Area under the curve :  " << area_under_curve << endl;
/* To draw normalized plots; you need to comment next two lines to draw usual plots  */
//    norm_area_under_curve = read_graph_file(gr3, fname, ydim, area_under_curve);
//    cout << fname <<  "  Area under the normalized curve :  " << norm_area_under_curve << endl;
	}

   }

yTitle="d#sigma/d"+xtitle[ntab-1] + " ["+ydim+"] ";



// Set maximum point as a maximum of Y axis

    double maxgr[3];
    for(int igr=0; igr<numlines; igr++)
     { 
       if(igr==0)maxgr[igr]=gr1->GetHistogram()->GetMaximum();
       if(igr==1)maxgr[igr]=gr2->GetHistogram()->GetMaximum();
       if(igr==2)maxgr[igr]=gr3->GetHistogram()->GetMaximum();
 //      cout<<maxgr[igr]<<endl;
     }
     double grmaximum=*max_element( maxgr, maxgr+numlines);
    gr1->SetMaximum(grmaximum);

/*
// Set fixing maximum 

    double maxgr[3];
    for(int igr=0; igr<numlines; igr++)
     { 
       if(igr==0)maxgr[igr]=gr1->GetHistogram()->GetMaximum();
       if(igr==1)maxgr[igr]=gr2->GetHistogram()->GetMaximum();
       if(igr==2)maxgr[igr]=gr3->GetHistogram()->GetMaximum();
 //      cout<<maxgr[igr]<<endl;
     }
     double grmaximum=*max_element( maxgr, maxgr+numlines);
    gr1->SetMaximum(1.2);
*/

// Set fixing minimum

    double mingr[3];
    for(int igr=0; igr<numlines; igr++)
     { 
       if(igr==0)mingr[igr]=gr1->GetHistogram()->GetMinimum();
       if(igr==1)mingr[igr]=gr2->GetHistogram()->GetMinimum();
       if(igr==2)mingr[igr]=gr3->GetHistogram()->GetMinimum();
     }
     double grminimum=*min_element( mingr, mingr+numlines);
    gr1->SetMinimum(0);


    c1->cd();
      gr1->SetLineColor(4);
      gr1->SetLineStyle(3);
      gr1->SetLineWidth(4);
      test1->SetLineColor(4);
      test1->SetLineStyle(3);
      test1->SetLineWidth(4);
      gr1->SetMarkerColor(4);
      gr1->SetMarkerStyle(21);
      gr1->SetMarkerSize(0.5);
      gr1->Draw("AC");
      gr1->SetTitle(procName);
      gr1->GetXaxis()->SetTitle(xtitle[ntab-1].c_str());
      gr1->GetYaxis()->SetTitle(yTitle.c_str());
      gr1->Draw("AC");
//      Double_t scale1=1./test1->Integral();
      leg->AddEntry(test1,"Curve no.1");   // label for the first curve

   if(numlines>1){
      gr2->SetLineColor(2);
      gr2->SetLineStyle(2);
      gr2->SetLineWidth(4);
      gr2->SetMarkerColor(2);
      gr2->SetMarkerStyle(21);
      gr2->SetMarkerSize(0.5);
      test2->SetLineColor(2);
      test2->SetLineStyle(2);
      test2->SetLineWidth(4);
      leg->AddEntry(test2,"Curve no.2");  //lable for the second curve
      gr2->Draw("C"); 
    }
    if(numlines>2){
      gr3->SetLineColor(1);
      gr3->SetLineStyle(1);
      gr3->SetLineWidth(4);
      test3->SetLineColor(1);
      test3->SetLineStyle(1);
      test3->SetLineWidth(4);
      leg->AddEntry(test3,"Curve no.3");  //label for the third curve
      gr3->Draw("C");
     }

      leg->Draw("SAME");
      c1->Update();

     if(eps){
      c1->Print(Outfileeps);
//      gSystem->Exec("(gv `ls -1rt *.eps | tail -1`) &");
      }
     if(gif) c1->Print(Outfilegif);

 }



double read_graph_file(TGraph * gr, char * fname, char * ydim,double tot_square )
{ 
  
 char line[100];
 char  procName[100],xName[60], yName[60];
 double xMin, xMax, tmp, tmp_tmp, etmp, x, x_length;
 double ytotal = 0;
 int dim;
 ifstream file;
 cout << "FILE: "<<fname<<endl;

    int nline=0;
    file.open(fname);
     while(file.getline(line,100))
    {
      nline++; 
      if(nline==1){sscanf(line, "%[^\n]", procName); cout<< procName<<endl;}
      if(nline==2){
        sscanf(line,"%*[^\"]%*c%[^\"]%*c%*s%lf%*s%lf%*s%d%*c", xName, &xMin, &xMax, &dim);
        cout<<xName<<" "<<xMin<<" "<<xMax<<" "<<dim <<endl;
        x_length = xMax - xMin;
        cout<<  "X-length " << x_length <<endl;
       }
      if(nline==3){
         sscanf(line, "%[^\n]", yName);
	 sscanf(line, "%*[^\[]%*c%[^\]]%*c", ydim);
	 cout<< ydim<<endl;
	}
      if(nline>3)
      {
        sscanf(line,"%lf +/- %lf",&tmp,&etmp);
 	x=xMin+(nline-3)*(xMax-xMin)/dim;
       tmp_tmp = tmp/tot_square;
       ytotal = ytotal + tmp_tmp ; 
       gr->SetPoint(nline-4,x,tmp_tmp);
      }

     }
    int number_bins = 100; // number of bins
    double area = ytotal*x_length/number_bins ; 

    file.clear();
    file.close();
    return area;
}
 

